## ros-dashing-tf2-ros 0.11.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(tf2_ros)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(NOT ANDROID)
  set(TF2_PY tf2_py)
endif()

find_package(ament_cmake REQUIRED)
# TODO(tfoote) uncomment when reenabling server client interfaces
# find_package(actionlib REQUIRED)
# find_package(actionlib_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(message_filters REQUIRED)
find_package(rclcpp REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_msgs REQUIRED)

include_directories(include
  ${geometry_msgs_INCLUDE_DIRS}
  ${message_filters_INCLUDE_DIRS}
  ${rclcpp_INCLUDE_DIRS}
  ${tf2_INCLUDE_DIRS}
  ${tf2_msgs_INCLUDE_DIRS}
  )

# tf2_ros library
add_library(${PROJECT_NAME} SHARED
  src/buffer.cpp
  src/transform_listener.cpp
  # src/buffer_client.cpp
  # src/buffer_server.cpp
  src/transform_broadcaster.cpp
  src/static_transform_broadcaster.cpp
)

target_link_libraries(${PROJECT_NAME}
  ${geometry_msgs_LIBRARIES}
  ${message_filters_LIBRARIES}
  ${rclcpp_LIBRARIES}
  ${tf2_LIBRARIES}
  ${tf2_msgs_LIBRARIES}
  )

target_compile_definitions(${PROJECT_NAME} PRIVATE "TF2_ROS_BUILDING_DLL")

# TODO(tfoote) port server client interfaces
# # buffer_server executable
# add_executable(buffer_server src/buffer_server_main.cpp)
# add_dependencies(${PROJECT_NAME}_buffer_server tf2_msgs_gencpp)
# target_link_libraries(${PROJECT_NAME}_buffer_server
#   ${PROJECT_NAME}
#   ${catkin_LIBRARIES}
#   ${Boost_LIBRARIES}
# )


# static_transform_publisher
add_executable(static_transform_publisher
  src/static_transform_broadcaster_program.cpp
)
target_link_libraries(static_transform_publisher
  ${PROJECT_NAME}
  ${geometry_msgs_LIBRARIES}
  ${rclcpp_LIBRARIES}
  ${tf2_LIBRARIES}
  ${tf2_msgs_LIBRARIES}
  )

add_executable(tf2_echo
  src/tf2_echo.cpp
)
target_link_libraries(tf2_echo
  ${PROJECT_NAME}
  ${geometry_msgs_LIBRARIES}
  ${rclcpp_LIBRARIES}
  ${tf2_LIBRARIES}
  ${tf2_msgs_LIBRARIES}
  )

  add_executable(tf2_monitor
    src/tf2_monitor.cpp
  )
  target_link_libraries(tf2_monitor
    ${PROJECT_NAME}
    ${geometry_msgs_LIBRARIES}
    ${rclcpp_LIBRARIES}
    ${tf2_LIBRARIES}
    ${tf2_msgs_LIBRARIES}
    )

# Install rules
install(TARGETS
  ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# install executables
install(TARGETS
  # buffer_server
  static_transform_publisher
  tf2_echo
  tf2_monitor
  DESTINATION lib/${PROJECT_NAME}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
)


# Tests
if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  ament_add_gtest(test_buffer test/test_buffer.cpp)
  target_link_libraries(test_buffer ${PROJECT_NAME})

  # Adds a tf2_ros message_filter unittest that uses
  # multiple target frames and a non-zero time tolerance
  ament_add_gtest(${PROJECT_NAME}_test_message_filter test/message_filter_test.cpp)
  target_link_libraries(${PROJECT_NAME}_test_message_filter ${PROJECT_NAME})

  ament_add_gtest(${PROJECT_NAME}_test_transform_listener test/test_transform_listener.cpp)
  target_link_libraries(${PROJECT_NAME}_test_transform_listener ${PROJECT_NAME})

  ament_add_gtest(${PROJECT_NAME}_test_static_transform_broadcaster test/test_static_transform_broadcaster.cpp)
  target_link_libraries(${PROJECT_NAME}_test_static_transform_broadcaster ${PROJECT_NAME})

  ament_add_gtest(${PROJECT_NAME}_test_transform_broadcaster test/test_transform_broadcaster.cpp)
  target_link_libraries(${PROJECT_NAME}_test_transform_broadcaster ${PROJECT_NAME})
# TODO(tfoote) port tests to use ROS2 instead of ROS1 api.
if (false)

# new requirements for testing
find_package(catkin REQUIRED COMPONENTS
  actionlib
  actionlib_msgs
  geometry_msgs
  message_filters
  roscpp
  rosgraph
  rospy
  rostest
  tf2
  tf2_msgs
  ${TF2_PY}
)

# tf2_ros_test_listener
add_executable(${PROJECT_NAME}_test_listener EXCLUDE_FROM_ALL test/listener_unittest.cpp)
add_dependencies(${PROJECT_NAME}_test_listener tf2_msgs_gencpp)
add_executable(${PROJECT_NAME}_test_time_reset EXCLUDE_FROM_ALL test/time_reset_test.cpp)
add_dependencies(${PROJECT_NAME}_test_time_reset tf2_msgs_gencpp)
target_link_libraries(${PROJECT_NAME}_test_listener
  ${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${GTEST_LIBRARIES}
)

target_link_libraries(${PROJECT_NAME}_test_time_reset
  ${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${GTEST_LIBRARIES}
)

add_dependencies(tests ${PROJECT_NAME}_test_listener)
add_dependencies(tests ${PROJECT_NAME}_test_time_reset)

add_rostest(test/transform_listener_unittest.launch)
add_rostest(test/transform_listener_time_reset_test.launch)

endif()
endif()

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(message_filters)
ament_export_dependencies(rclcpp)
ament_export_dependencies(tf2_msgs)
ament_export_dependencies(tf2)
ament_package()

=== debian/changelog ===
ros-dashing-tf2-ros (0.11.6-1bionic) bionic; urgency=high



 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 10 Dec 2019 06:00:00 -0000

ros-dashing-tf2-ros (0.11.5-1bionic) bionic; urgency=high

  * Add missing export build dependencies (#135 <https://github.com/ros2/geometry2/issues/135>) (#152 <https://github.com/ros2/geometry2/issues/152>)
  * Contributors: Jacob Perron

 -- Tully Foote <tfoote@osrfoundation.org>  Fri, 06 Sep 2019 05:00:00 -0000

ros-dashing-tf2-ros (0.11.4-1bionic) bionic; urgency=high

  * Allow tf2_monitor to be run with ROS command line args (#140 <https://github.com/ros2/geometry2/issues/140>)
  * Drop misleading ROS logging macros from tf2_monitor (#139 <https://github.com/ros2/geometry2/issues/139>)
  * Reduce CPU usage with an ABI compatible fix (#133 <https://github.com/ros2/geometry2/issues/133>)
  * Fix the MessageFilter init order(#137 <https://github.com/ros2/geometry2/issues/137>)
  * Contributors: Chris Lalancette, Dan Rose, Scott K Logan

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 31 Jul 2019 05:00:00 -0000

ros-dashing-tf2-ros (0.11.3-1bionic) bionic; urgency=high

  * stop spinning TransformListener thread node in destructor (#114 <https://github.com/ros2/geometry2/issues/114>)
  * Store dedicated transform listener thread as a std::unique_ptr (#111 <https://github.com/ros2/geometry2/issues/111>)
  * enable pedantic for tf2_ros (#115 <https://github.com/ros2/geometry2/issues/115>)
  * Contributors: Hunter L. Allen, Karsten Knese, bpwilcox

 -- Tully Foote <tfoote@osrfoundation.org>  Fri, 24 May 2019 05:00:00 -0000

ros-dashing-tf2-ros (0.11.2-1bionic) bionic; urgency=high

  * Remove stray semicolon which causes compiler error when using -Werror=pedantic (#112 <https://github.com/ros2/geometry2/issues/112>)
  * Contributors: Michael Jeronimo

 -- Tully Foote <tfoote@osrfoundation.org>  Mon, 20 May 2019 05:00:00 -0000

ros-dashing-tf2-ros (0.11.1-1bionic) bionic; urgency=high

  * use node interfaces throughout tf2_ros (#108 <https://github.com/ros2/geometry2/issues/108>)
  * changes to avoid deprecated API's (#107 <https://github.com/ros2/geometry2/issues/107>)
  * Fix call to create_publisher after API changed (#105 <https://github.com/ros2/geometry2/issues/105>)
  * Use node interfaces for static transform broadcaster (#104 <https://github.com/ros2/geometry2/issues/104>)
  * Contributors: Emerson Knapp, Karsten Knese, William Woodall

 -- Tully Foote <tfoote@osrfoundation.org>  Thu, 09 May 2019 05:00:00 -0000

ros-dashing-tf2-ros (0.11.0-1bionic) bionic; urgency=high

  * Updated to use node inteface pointers in the MessageFilter class. (#96 <https://github.com/ros2/geometry2/pull/96>)
  * Updated message_filter.h. (#91 <https://github.com/ros2/geometry2/issues/91>)
  * Contributors: Michael Jeronimo, Sagnik Basu

 -- Tully Foote <tfoote@osrfoundation.org>  Sun, 14 Apr 2019 05:00:00 -0000

ros-dashing-tf2-ros (0.10.1-1bionic) bionic; urgency=high

  * Allow static_transform_publisher to be run with ros arguments ros2`#80 <https://github.com/ros2/geometry2/issues/80>`_ (#82 <https://github.com/ros2/geometry2/issues/82>)
  * Contributors: Lucas Walter

 -- Tully Foote <tfoote@osrfoundation.org>  Thu, 06 Dec 2018 06:00:00 -0000

ros-dashing-tf2-ros (0.10.0-1bionic) bionic; urgency=high

  * Port tf2 ros message filter with ros2 tf2 and message filters (#81 <https://github.com/ros2/geometry2/issues/81>)
    * Port tf2 message filter to ros2
    - remove APIs to node callback queue due to no callback queue
    in ros2 now
    - Change failure callback register with failure prompting due to
    no corresponding boost signal2 in C++11 and later
    - Fix expected transform count in case of time tolerance
    - Upgrade all message counts to 64 bitThis should resolve C4267 warnings about downgrading a size_t.
  * Export tf2 dependency from tf2_ros (#72 <https://github.com/ros2/geometry2/issues/72>)
  * rclcpp time jump callback signature (#69 <https://github.com/ros2/geometry2/issues/69>)
  * Use ros2 time (#67 <https://github.com/ros2/geometry2/issues/67>)
  * Contributors: Carl Delsey, Ethan Gao, Shane Loretz

 -- Tully Foote <tfoote@osrfoundation.org>  Thu, 22 Nov 2018 06:00:00 -0000

ros-dashing-tf2-ros (0.5.15-1bionic) bionic; urgency=high

  * tf2_ros: add option to unregister TransformListener (#201 <https://github.com/ros/geometry2/issues/201>)
  * Contributors: Hans-Joachim Krauch

 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 24 Jan 2017 06:00:00 -0000

ros-dashing-tf2-ros (0.5.14-1bionic) bionic; urgency=high

  * Drop roslib.load_manifest (#191 <https://github.com/ros/geometry2/issues/191>)
  * Adds ability to load TF from the ROS parameter server.
  * Code linting & reorganization
  * Fix indexing beyond end of array
  * added a static transform broadcaster in python
  * lots more documentation
  * remove BufferCore doc, add BufferClient/BufferServer doc for C++, add Buffer/BufferInterface Python documentation
  * Better overview for Python
  * Contributors: Eric Wieser, Felix Duvallet, Jackie Kay, Mikael Arguedas, Mike Purvis

 -- Tully Foote <tfoote@osrfoundation.org>  Mon, 16 Jan 2017 06:00:00 -0000

ros-dashing-tf2-ros (0.5.13-1bionic) bionic; urgency=high

  * fix documentation warnings
  * Adding tests to package
  * Contributors: Laurent GEORGE, Vincent Rabaud

 -- Tully Foote <tfoote@osrfoundation.org>  Fri, 04 Mar 2016 06:00:00 -0000

ros-dashing-tf2-ros (0.5.12-1bionic) bionic; urgency=high

  * remove annoying gcc warning
    This is because the roslog macro cannot have two arguments that are
    formatting strings: we need to concatenate them first.
  * break canTransform loop only for non-tiny negative time deltas
    (At least) with Python 2 ros.Time.now() is not necessarily monotonic
    and one can experience negative time deltas (usually well below 1s)
    on real hardware under full load. This check was originally introduced
    to allow for backjumps with rosbag replays, and only there it makes sense.


=== debian/control ===
Source: ros-dashing-tf2-ros
Section: misc
Priority: optional
Maintainer: Tully Foote <tfoote@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-dashing-ament-cmake, ros-dashing-ament-cmake-gtest, ros-dashing-geometry-msgs, ros-dashing-message-filters, ros-dashing-rclcpp, ros-dashing-std-msgs, ros-dashing-tf2, ros-dashing-tf2-msgs, ros-dashing-ros-workspace
Homepage: http://www.ros.org/wiki/tf2_ros
Standards-Version: 3.9.2

Package: ros-dashing-tf2-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-dashing-geometry-msgs, ros-dashing-message-filters, ros-dashing-rclcpp, ros-dashing-std-msgs, ros-dashing-tf2, ros-dashing-tf2-msgs, ros-dashing-ros-workspace
Description: This package contains the ROS bindings for the tf2 library, for both Python and C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DAMENT_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-tf2-ros//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
